import { fromPairs, map, omit, pipe, toPairs, type } from "ramda";

export const deepOmit = <T = any, K = any>(
  names: readonly string[],
  value: K
): T => {
  switch (type(value)) {
    case "Array":
      return (value as unknown as Array<any>).map((item: any) =>
        deepOmit(names, item)
      ) as unknown as T;
    case "Object":
      return pipe(
        omit(names),
        toPairs,
        map(([key, val]) => [key, deepOmit(names, val)] as any),
        fromPairs
      )(value) as unknown as T;
    default:
      return value as unknown as T;
  }
};
